#include "Calculator_Demo_objects.h"
#include "Calculator_Demo_resources.h"

//--------------------- User code ---------------------//
TLabel *label_selected;
char temp_label[20];
typedef enum {_taFirst, _taSecond} TOperand;

void ClearLabel( TLabel *_label) {
  strcpy(_label->Caption, " ");
}

void Refresh_Screen() {
  DrawScreen(&Calc_Demo);
}

void ClearLabels() {
  label_selected = &Label1;
  ClearLabel(&Label1);
  ClearLabel(&Label2);
  ClearLabel(&Label3);
  ClearLabel(&Label6);
  Refresh_Screen();
}

void Set_Defaults() {
  ClearLabels();
}

void Change_Label(char *Achar) {
  strcat(label_selected->Caption, Achar);
  Refresh_Screen();
}

void Change_Operation(char *Achar) {
  label_selected = &Label2;
  strcpy(label_selected->Caption, Achar);
  label_selected = &Label3;
  Refresh_Screen();
}

char Check_Value(long AValue, TOperand AOperand) {
  if ((AValue >= -32768) && (AValue <= 32767))
    return 0;
  else {
    if (AOperand == _taFirst)
      label_selected = &Label1;
    else
      label_selected = &Label3;
    strcpy(label_selected->Caption, "Out of Range");
    Refresh_Screen();
    return 1;
  }
}

//----------------- End of User code ------------------//

// Event Handlers
void Button2OnClick() {
  // Seven
  if (label_selected != 0) {
    Change_Label("7");
  }
}

void Button3OnClick() {
  // Eight
  if (label_selected != 0) {
    Change_Label("8");
  }
}

void Button5OnClick() {
  // Nine
  if (label_selected != 0) {
    Change_Label("9");
  }
}

void Button7OnClick() {
  // Four
  if (label_selected != 0) {
    Change_Label("4");
  }
}

void Button8OnClick() {
  // Five
  if (label_selected != 0) {
    Change_Label("5");
  }
}

void Button10OnClick() {
  // Six
  if (label_selected != 0) {
    Change_Label("6");
  }
}

void Button12OnClick() {
  // One
  if (label_selected != 0) {
    Change_Label("1");
  }
}

void Button13OnClick() {
  // Two
  if (label_selected != 0) {
    Change_Label("2");
  }
}

void Button15OnClick() {
  // Three
  if (label_selected != 0) {
    Change_Label("3");
  }
}

void Button17OnClick() {
  // Zero
  if (label_selected != 0) {
    Change_Label("0");
  }
}

void Button20OnClick() {
  // Change Sign
char temp[20] = " -";
  if ((label_selected != 0) && (label_selected != &Label2)) {
    strcpy(temp_label, label_selected->Caption);
    Ltrim(temp_label);
    switch (temp_label[0]) {
      case '-' : {
        temp_label[0] = 32;
        break;
      }
      default : {
        strcat(temp, temp_label);
        strcpy(temp_label, temp);
        break;
      }
    }

    strcpy(label_selected->Caption, temp_label);
    Refresh_Screen();
  }
}

void Button4OnClick() {
  // Divide
  Change_Operation(" /");
}

void Button9OnClick() {
  // Multiply
  Change_Operation(" *");
}

void Button14OnClick() {
  // Subtract
  Change_Operation(" -");
}

void Button19OnClick() {
  // Add
  Change_Operation(" +");
}

void Button6OnClick() {
  // Clear
  ClearLabels();
}

void Button11OnClick() {
  // Delete
unsigned int count;
unsigned int result;

  // Delete
  count = strlen(label_selected->Caption);
  if (count > 1) {
    if (label_selected == &Label1) {
      strcpy(temp_label, Label1_Caption);
      temp_label[count-1] = 0;
      strcpy(Label1_Caption, temp_label);
    }
    else
      if (label_selected == &Label2) {
        strcpy(temp_label, Label2_Caption);
        temp_label[count-1] = 0;
        strcpy(Label2_Caption, temp_label);
      }
      else
        if (label_selected == &Label3) {
          strcpy(temp_label, Label3_Caption);
          temp_label[count-1] = 0;
          strcpy(Label3_Caption, temp_label);
        }
  }
  else {
    if (label_selected == &Label1) {
      strcpy(Label1_Caption, " ");
    }
    else
      if (label_selected == &Label2) {
        strcpy(Label2_Caption, " ");
        label_selected = &Label1;
      }
      else
        if (label_selected == &Label3) {
          strcpy(Label3_Caption, " ");
          label_selected = &Label2;
        }
  }
  Refresh_Screen();
}

void Button16OnClick() {
long templ;
int first_operand, second_operand;
float result;
char first_operand_str[6];
char second_operand_str[6];
unsigned short counter, i;
char temp[5] = " ";
  // Calculate
  // -32768 .. 32767
  first_operand = 0;
  second_operand = 0;
  i = 0;
  for (counter = 1; counter < 7; counter++) {
    first_operand_str[i]  = Label1_Caption[counter];
    second_operand_str[i] = Label3_Caption[counter];
    i++;
  }

  templ = atol(first_operand_str);
  if (Check_Value(templ, _taFirst))
    return;
  first_operand = templ;
  templ = atol(second_operand_str);
  if (Check_Value(templ, _taSecond))
    return;
  second_operand = templ;

  strcpy(temp_label, Label2.Caption);
  Ltrim(temp_label);

  switch (temp_label[0]) {
    case '+' : {
         result = (long)first_operand + second_operand;
         templ = (ceil(result));
         LongToStr(templ, Label6_Caption);
         break;
       }
    case '-' : {
         result = (long)first_operand - second_operand;
         templ = ceil(result);
         LongToStr(templ, Label6_Caption);
         break;
       }
    case '*' : {
         result = (long)first_operand * second_operand;
         templ = ceil(result);
         LongToStr(templ, Label6_Caption);
         break;
       }
    case '/': {
         result = (float)first_operand / second_operand;
         FloatToStr(result, Label6_Caption);
         break;
       }
  }
  Refresh_Screen();
}

void Button18OnClick() {
  Set_Defaults();
}

void ButtonRound1OnClick() {
  DrawScreen(&Main_Screen);
}